using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace CfChart
{
    /// <summary>
    /// ͼ
    /// </summary>
    public partial class ColumnChart : AxisChart
    {
        public ColumnChart()
        {
            InitializeComponent();
        }

        /// <summary>
        /// ͼ
        /// </summary>
        protected override void DrawChart()
        {
            base.DrawChart();

            // ״ͼı
            int serialWidth = axisWidth / serialCount - 1;
            int barWidth = axisWidth / (seriesCount * (serialCount + 1) + 1);
            int x;

            for (int i = 0; i < seriesCount; i++)
            {
                x = origin.X + i * barWidth;

                for (int j = 0; j < serialCount; j++)
                {
                    if (i == 0)
                    {
                        Label label = new Label();
                        label.Location = new Point(x + 2, origin.Y + 3);
                        label.Size = new Size(serialWidth - 4, 40);
                        label.Text = DataSeries[0].Serials[j].Label;
                        label.TextAlign = ContentAlignment.TopCenter;
                        Controls.Add(label);

                        graphics.DrawLine(new Pen(Color.DarkGray), x + serialWidth, origin.Y, x + serialWidth, origin.Y + 3);
                    }

                    int barHeight = 0 - GetSerialHeight(axisHeight, maxScale[i], minScale[i], DataSeries[i].Serials[j].Data);
                    graphics.FillRectangle(new SolidBrush(DataSeries[i].Color), x + barWidth / 2, origin.Y, barWidth, barHeight);
                    x += serialWidth;
                }
            }
        }
    }
}