﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace CfChart
{
    public partial class LineChart : AxisChart
    {
        public LineChart()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 绘制图表
        /// </summary>
        protected override void DrawChart()
        {
            base.DrawChart();

            Point[][] points = new Point[seriesCount][];

            int serialWidth = axisWidth / serialCount - 1;
            int x;

            for (int i = 0; i < seriesCount; i++)
            {
                x = origin.X;
                points[i] = new Point[serialCount];

                for (int j = 0; j < serialCount; j++)
                {
                    if (i == 0)
                    {
                        Label label = new Label();
                        label.Location = new Point(x + 2, origin.Y + 3);
                        label.Size = new Size(serialWidth - 4, 40);
                        label.Text = DataSeries[0].Serials[j].Label;
                        label.TextAlign = ContentAlignment.TopCenter;
                        Controls.Add(label);

                        graphics.DrawLine(new Pen(Color.DarkGray), x + serialWidth, origin.Y, x + serialWidth, origin.Y + 3);
                    }

                    int serialHeight = 0 - GetSerialHeight(axisHeight, maxScale[i], minScale[i], DataSeries[i].Serials[j].Data);
                    points[i][j] = new Point(x + serialWidth / 2, origin.Y + serialHeight);
                    graphics.FillRectangle(new SolidBrush(DataSeries[i].Color), points[i][j].X - 2, points[i][j].Y - 1, 4, 4);

                    x += serialWidth;
                }

                graphics.DrawLines(new Pen(DataSeries[i].Color), points[i]);
            }
        }
    }
}
