﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;

namespace CfChart
{
    /// <summary>
    /// 预定义的色系
    /// </summary>
    /// <remarks>根据给定的数值返回预定义的色系。超过20个元素以上请自行设置。</remarks>
    public class PredefinedColors
    {
        private Color[] colors;

        /// <summary>
        /// 预定义的色系
        /// </summary>
        public Color[] Colors
        {
            get { return colors; }
        }

        public PredefinedColors(int count)
        {
            switch (count / 5)
            {
                case 0:
                    colors = new Color[5];
                    colors[0] = Color.FromArgb(79, 129, 189);
                    colors[1] = Color.FromArgb(192, 80, 77);
                    colors[2] = Color.FromArgb(155, 187, 89);
                    colors[3] = Color.FromArgb(128, 100, 162);
                    colors[4] = Color.FromArgb(75, 172, 198);
                    break;

                case 1:
                    colors = new Color[10];
                    colors[0] = Color.FromArgb(69, 114, 167);
                    colors[1] = Color.FromArgb(170, 70, 67);
                    colors[2] = Color.FromArgb(137, 165, 78);
                    colors[3] = Color.FromArgb(113, 88, 143);
                    colors[4] = Color.FromArgb(65, 152, 175);
                    colors[5] = Color.FromArgb(219, 132, 61);
                    colors[6] = Color.FromArgb(147, 169, 207);
                    colors[7] = Color.FromArgb(209, 147, 146);
                    colors[8] = Color.FromArgb(185, 205, 150);
                    colors[9] = Color.FromArgb(169, 155, 189);
                    break;

                case 2:
                    colors = new Color[15];
                    colors[0] = Color.FromArgb(64, 105, 156);
                    colors[1] = Color.FromArgb(158, 65, 62);
                    colors[2] = Color.FromArgb(127, 154, 72);
                    colors[3] = Color.FromArgb(105, 81, 133);
                    colors[4] = Color.FromArgb(60, 141, 163);
                    colors[5] = Color.FromArgb(204, 123, 56);
                    colors[6] = Color.FromArgb(79, 129, 189);
                    colors[7] = Color.FromArgb(192, 80, 77);
                    colors[8] = Color.FromArgb(155, 187, 89);
                    colors[9] = Color.FromArgb(128, 100, 162);
                    colors[10] = Color.FromArgb(75, 172, 198);
                    colors[11] = Color.FromArgb(247, 150, 70);
                    colors[12] = Color.FromArgb(170, 186, 215);
                    colors[13] = Color.FromArgb(217, 170, 169);
                    colors[14] = Color.FromArgb(198, 214, 172);
                    break;

                case 3:
                    colors = new Color[20];
                    colors[0] = Color.FromArgb(60, 100, 148);
                    colors[1] = Color.FromArgb(150, 61, 59);
                    colors[2] = Color.FromArgb(121, 146, 68);
                    colors[3] = Color.FromArgb(99, 77, 126);
                    colors[4] = Color.FromArgb(57, 134, 155);
                    colors[5] = Color.FromArgb(194, 117, 53);
                    colors[6] = Color.FromArgb(73, 120, 177);
                    colors[7] = Color.FromArgb(179, 74, 71);
                    colors[8] = Color.FromArgb(145, 175, 83);
                    colors[9] = Color.FromArgb(119, 93, 151);
                    colors[10] = Color.FromArgb(70, 161, 185);
                    colors[11] = Color.FromArgb(231, 140, 65);
                    colors[12] = Color.FromArgb(126, 155, 200);
                    colors[13] = Color.FromArgb(202, 126, 125);
                    colors[14] = Color.FromArgb(174, 198, 131);
                    colors[15] = Color.FromArgb(155, 137, 179);
                    colors[16] = Color.FromArgb(124, 187, 207);
                    colors[17] = Color.FromArgb(248, 170, 121);
                    colors[18] = Color.FromArgb(182, 195, 220);
                    colors[19] = Color.FromArgb(221, 182, 181);
                    break;

                default:
                    throw new ArgumentException("超过20个元素以上请自行设置图表颜色。");
            }
        }
    }
}
